View Issue Details

IDProjectCategoryView StatusLast Update
0002225SketcherBugpublic2015-09-11 20:20
Reportertriplus Assigned Toabdullah  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformLinuxOSUbuntuOS Version14.04
Product Version 
Target VersionFixed in Version0.16 
Summary0002225: Deleting link to external geometry crashes FreeCAD
DescriptionThis isn't the usual work flow nonetheless FreeCAD should not crash.
Steps To Reproduce- Create Sketch and add rectangle to it.
- Pad it.
- Create Sketch001 on top face of Pad.
- Add 4 links to external geometry.
- Go back to Sketch and delete 2 edges of rectangle and add a new line to form a triangle.

It's normal and expected Sketch001 starts to misbehave as for example it can lose support... Trying to edit it adding additional links to external geometry is not possible. That probably is normal and expected behavior.

Selecting all 4 links to external geometry and pressing delete key will remove just 2 or 3 links to external geometry. Selecting remaining links to external geometry again and pressing delete key will crash FreeCAD.


Additional Informationhttp://forum.freecadweb.org/viewtopic.php?f=10&t=12179
TagsNo tags attached.
FreeCAD Information

Activities

There are no notes attached to this issue.

Related Changesets

FreeCAD: master 47c0859c

2015-09-08 20:08:47

abdullah


Committer: wmayer Details Diff
Sketcher: Bug fixes: inability to create links to external geometry

=================================================================

First bug: Inability to create links to external geometry as described here:
http://forum.freecadweb.org/download/file.php?id=16668

Second bug: FC crashes on changing the support after having imported external geometry as described here:
http://forum.freecadweb.org/viewtopic.php?f=10&t=12380

and solving this ticket:
http://www.freecadweb.org/tracker/view.php?id=2225

Solution to first bug:

If for some reason a sketch ends up having a list of external geometries (property) that can not be recreated (rebuilt),
they remain latent, do not show the external elements in the elements widget or in the screen and prevent adding the
elements again.

In cases where the saved file contains invalid external geometry links (which will give raise to a handled exception that would prevent external geometry creation),
this condition gets detected during restore and the invalid links are deleted before external geometry creation, so as to allow the rest of external links to be recreated.

Solution to second bug:

It is also related to invalid external links (the link was existing, but upon change on the support, it is possible that an external edge is no longer valid, reduction of edges in support).
This situation is detected upon entering into edit mode, and the invalid ones are deleted.

Note that there is still the possibility for the user to remap an invalid sketch BEFORE editing, if the remapping is successful, it may not be necessary to delete links (all depends on the
specific case).
Affected Issues
0002225
mod - src/Mod/Sketcher/App/SketchObject.cpp Diff File
mod - src/Mod/Sketcher/App/SketchObject.h Diff File
mod - src/Mod/Sketcher/Gui/ViewProviderSketch.cpp Diff File

Issue History

Date Modified Username Field Change
2015-08-22 00:17 triplus New Issue
2015-08-22 09:51 abdullah Assigned To => abdullah
2015-08-22 09:51 abdullah Status new => assigned
2015-09-11 20:19 wmayer Changeset attached => FreeCAD Master master 47c0859c
2015-09-11 20:20 wmayer Status assigned => closed
2015-09-11 20:20 wmayer Resolution open => fixed
2015-09-11 20:20 wmayer Fixed in Version => 0.16